/***********************************************************************************\
 * Copyright (C) 2004 Steven Deprez                                                *
 *                                                                                 *
 * This file is part of zasm                                                       *
 *                                                                                 *
 * zasm is free software; you can redistribute it and/or modify                    *
 * it under the terms of the GNU General Public License as published by            *
 * the Free Software Foundation; either version 2 of the License, or               *
 * (at your option) any later version.                                             *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful,                 *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                  *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   *
 * GNU General Public License for more details.                                    *
 *                                                                                 *
 * You should have received a copy of the GNU General Public License               *
 * along with this program; if not, write to the Free Software                     *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.     *
 *                                                                                 *
 * In addition, as a special exception, Peter-Martijn Kuipers gives permission     *
 * to link the code of this program with the appsign library, and distribute       *
 * linked combinations including the two. If you modify this file, you may extend  *
 * this exception to your version of the file, but you are not obligated to do so. *
 * If you do not wish to do so, delete this exception statement form your version. *
\***********************************************************************************/

#ifndef CONVERTER_H
#define CONVERTER_H

#include <config.h>

#ifdef STDC_HEADERS
#include <stdio.h>
#endif

struct type_t
{
  char *name;
  int ID;
  int (*filter)(int calc_type, int var_type, char *IH_file, char *outfile);
};

struct calc_t
{
  char *name;
  int ID;
  struct type_t *types;
};

struct page_t
{
  int size;
  char *data; // binary
};

struct pages_t
{
  int count;
  struct page_t *pages;
};

struct IH_line_t
{
  int size;
  int address;
  int type;
  char *data;
  int checksum;
};

// converter.c
#ifndef CONVERTER_C
extern struct calc_t current_calc;
extern struct type_t current_type;
extern char *infile;
extern char *outfile;
extern char *name;
extern int typechr;
#endif

char *l_basename(char *filename);
struct calc_t find_calc(char *name);
struct type_t find_type(char *name, struct type_t *types);
int main(int argc, char *argv[]);

// intel_hex.c
struct IH_line_t *IH_read_line(FILE *file);
struct pages_t *IH_read_bin(char *filename);
struct pages_t *IH_read_hex(char *filename);

// ti83p.c
int make_ti83p_app(int ct, int vt, char *infile, char *outfile);
int make_ti83p_8xk(int ct, int vt, char *infile, char *outfile);
int make_bin83p(int ct, int vt, char *infile, char *outfile);
int make_hex83p(int ct, int vt, char *infile, char *outfile);

// ti86.c
int make_bin86(int ct, int vt, char *infile, char *outfile);
int make_hex86(int ct, int vt, char *infile, char *outfile);

// raw.c
int make_raw_bin(int ct, int vt, char *infile, char *outfile);
int make_raw_hex(int ct, int vt, char *infile, char *outfile);

// common.c
int make_bin(int ct, int vt, char *infile, char *outfile);
int make_var(int ct, int vt, struct page_t *page, char *outfile);

#endif
