/***********************************************************************************\
 * Copyright (C) 2004 Steven Deprez                                                *
 *                                                                                 *
 * This file is part of zasm                                                       *
 *                                                                                 *
 * zasm is free software; you can redistribute it and/or modify                    *
 * it under the terms of the GNU General Public License as published by            *
 * the Free Software Foundation; either version 2 of the License, or               *
 * (at your option) any later version.                                             *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful,                 *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                  *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   *
 * GNU General Public License for more details.                                    *
 *                                                                                 *
 * You should have received a copy of the GNU General Public License               *
 * along with this program; if not, write to the Free Software                     *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.     *
 *                                                                                 *
 * In addition, as a special exception, Peter-Martijn Kuipers gives permission     *
 * to link the code of this program with the appsign library, and distribute       *
 * linked combinations including the two. If you modify this file, you may extend  *
 * this exception to your version of the file, but you are not obligated to do so. *
 * If you do not wish to do so, delete this exception statement form your version. *
\***********************************************************************************/

#define RAW_C 1
#include <config.h>

#include "converter.h"
#include "../errors/errors.h"

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

int make_raw_bin(int ct, int vt, char *infile, char *outfile)
{
  struct pages_t *pages;
  struct page_t *page;
  int i;
  FILE *f;

  if (!(pages = IH_read_bin(infile)))
    ERROR("internal error\n");
  page = pages->pages;
  if (!(f = fopen(outfile, "w")))
    ERROR("couldn't open file \"%s\"\n", outfile);
  for (i = 0; i<pages->count; i++)
    {
      if (fwrite(page[i].data, 1, page[i].size, f) < page[i].size)
	ERROR("I/O error\n");
      free(page[i].data);
    }
  free(page);
  if (fclose(f))
    ERROR("I/O error\n");
  free(pages);
  return 0;
}

int make_raw_hex(int ct, int vt, char *infile, char *outfile)
{
  struct pages_t *pages;
  struct page_t *page;
  int i;
  FILE *f;

  if (!(pages = IH_read_hex(infile)))
    ERROR("internal error\n");
  page = pages->pages;
  if (!(f = fopen(outfile, "w")))
    ERROR("couldn't open file \"%s\"\n", outfile);
  for (i = 0; i<pages->count; i++)
    {
      if (fwrite(page[i].data, 1, page[i].size, f) < page[i].size)
	ERROR("I/O error\n");
      free(page[i].data);
    }
  free(page);
  if (fclose(f))
    ERROR("I/O error\n");
  free(pages);
  return 0;
}
